/*
 * Egomania: prompt.c: Prompt parser.
 * Copyright (C) 2003 Kyle Donaldson <gile@gilex.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
#include "ego.h"

char * ego_prompt (void)
{
	char * ppt;
	char * p;
	char * ret;
	char * s;
	char * tmp;
	char * t;
	int ch;
	int slen;
	int i = 0;
	int j = 0;
	ppt = ego_config_get("/user/environment/prompt");
	if (!ppt)
		ppt = "\\u\\$ ";
	ppt = ego_var_parse(ppt);
	if (!ppt)
		return "# ";
	slen = strlen(ppt);
	p = ppt;
	ret = malloc(slen + 2);
	if (!ret)
		return "# ";
	tmp = malloc(2050);
	if (!tmp)
		return "# ";
	for (s = ret; ((ch = *p++) != '\0') && (j < slen); ) {
		if (ch == '\\') {
			memset(tmp, 0, 2050);
			switch (ch = *p++) {
				case '\0': break;
				case 'u':
					strcpy(tmp, ego_config_get("/user/environment/name"));
					break;
				case 'd':
					getcwd(tmp, 1024);
					break;
				case '$':
					if ((int) ego_config_get("/user/environment/uid") == 0)
						strcpy(tmp, "%");
					else
						strcpy(tmp, "$");
			}
			if (strlen(tmp) > 0) {
				s = realloc(ret, slen + strlen(tmp) + 2);
				if (!s)
					return "# ";
				ret = s;
				s = ret + j;
				slen += strlen(tmp);
				t = tmp;
				for (i = strlen(tmp); i > 0; i--) {
					*s++ = *t++;
					j++;
				}
			}
		} else {
			*s++ = ch;
			j++;
		}
	}
	*s = 0;
	return ret;
}
