/*
 * Egomania: strexp.c: String explosion; like a general argv[] builder.
 * Copyright (C) 2003 Kyle Donaldson <gile@gilex.net>
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to
 * deal in the Software without restriction, including without limitation the
 * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or
 * sell copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in
 * all copies or substantial portions of the Software.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
#include "ego.h"

char ** ego_strexp (char * str, char brk, int max)
{
	int ch = 1;
	int lch = 0;
	int i;
	int slen;
	int cnt = 0;
	int quote = 0;
	char ** vec;
	char ** vtmp;
	char * tmp;
	char * s;
	char * stmp;
	if (!str)
		return NULL;
	if (max == 0)
		max = 0x7FFFFFFF;
	vec = (char **) malloc(sizeof(char **) * 2);
	if (!vec)
		return NULL;
	slen = strlen(str);
	tmp = malloc(slen + 2);
	if (!tmp)
		return NULL;
	for (stmp = str; (ch != '\0') && (cnt < max);) {
		memset(tmp, 0, slen + 2);
		s = tmp;
		for (i = 0; ((i < slen) && ((ch = *stmp++) != '\0')); i++) {
			if ((lch != '\\') && ((ch == '\'') || (ch == '"') || (ch == '`'))) {
				if (quote == 0)
					quote = ch;
				else if (quote == ch)
					quote = 0;
				else
					*s++ = ch;
			} else if (((cnt + 1) < max) && (quote == 0) && (lch != '\\') && (ch == brk)) {
				break;
			}
			*s++ = ch;
			lch = ch;
		}
		*s = 0;
		vtmp = (char **) realloc((char **) vec, sizeof(char **) * (cnt + 2));
		if (!vtmp)
			return NULL;
		vec = vtmp;
		vec[cnt] = strdup(tmp);
		if (!vec[cnt])
			return NULL;
		cnt++;
	}
	vec[cnt] = NULL;
	return vec;
}
